;---------------------------------------------------------
; Synopsis:	Affiche une chaine de caracteres se terminant par 0x0
; Entree:	ds:si -> pointe sur la chaine a afficher
;---------------------------------------------------------
afficher:
	push ax
	push bx
.debut:
	lodsb		; ds:si -> al
	cmp al,0	; fin chaine ?
	jz .fin
	mov ah,0x0E	; appel au service 0x0e, int 0x10 du bios
	mov bx,0x07	; bx -> attribut, al -> caractere ascii
	int 0x10
        jmp .debut

.fin:
	pop bx
	pop ax
	ret
;---------------------------------------------------------

;---------------------------------------------------------
; Synopsis: conversion de chaine hexa en ascii
; Entree:
;	ds:si -> chaine hexa
;	cx -> nombre d'octets a convertir
; Sortie:
;	es:di -> chaine ascii terminee par '0x0'
;---------------------------------------------------------
hex2a:
	push ax
	push bx
	push dx
.debut:
	xor ax,ax
	xor bx,bx
	xor dx,dx
	lodsb
    ror ax,4
	mov bl,al
	mov dl,byte [tableau+bx]
	mov byte [es:di],dl
	inc di
    rol ax,4
	and al,0x0F
    mov bl,al
	mov dl,byte [tableau+bx]
	mov byte [es:di],dl
	inc di
    loop .debut
	mov byte [es:di],0

	pop dx
	pop bx
	pop ax
	ret

tableau db '0123456789ABCDEF'
;---------------------------------------------------------
