%include "kbd.asm"

;-------------------------------------------------------------------
; init_irq
;	Synopsis: fait correspondre un handler a une ISR.
;-------------------------------------------------------------------
init_irq:
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE		; 0 - division par 0
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*1	; 1 - step
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*2 	; 2 - NMI
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*3	; 3 - breakpoint
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*4	; 4 - overflow
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*5	; 5 - BOUND
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*6	; 6 - opcode invalide
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*7	; 7 - coproc. non valide
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*8	; 8 - double faute
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*9	; 9 - overrun
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*10	;10 - task state segment invalide
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*11	;11 - segment non present
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*12	;12 - stack exception
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*13	;13 - general prot. exception
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*14	;14 - page fault
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*15	;15 - reserve
	gateInit	 0x08,interrupts,INT_FLAG+PRESENT_F,0,IDTBASE+8*16	;16 - erreur coproc.
		; ... 
	gateInit	 0x08,irq0,INT_FLAG+PRESENT_F,0,IDTBASE+8*32	; IRQ0 - timer
	gateInit	 0x08,irq1,INT_FLAG+PRESENT_F,0,IDTBASE+8*33	; IRQ1 - keyboard
	gateInit	 0x08,irq2,INT_FLAG+PRESENT_F,0,IDTBASE+8*34	; IRQ2 cascade 
	gateInit	 0x08,irq3,INT_FLAG+PRESENT_F,0,IDTBASE+8*35	; IRQ3 - COM2 or COM4
	gateInit	 0x08,irq4,INT_FLAG+PRESENT_F,0,IDTBASE+8*36	; IRQ4 - COM1 or COM3
	gateInit	 0x08,irq5,INT_FLAG+PRESENT_F,0,IDTBASE+8*37	; IRQ5 - LPT2
	gateInit	 0x08,irq6,INT_FLAG+PRESENT_F,0,IDTBASE+8*38	; IRQ6 - floppy disk
	gateInit	 0x08,irq7,INT_FLAG+PRESENT_F,0,IDTBASE+8*39	; IRQ7 - LPT1
		; ...
	gateInit	 0x08,irq8,INT_FLAG+PRESENT_F,0,IDTBASE+8*112	; IRQ8 - real time clock
	gateInit	 0x08,irq9,INT_FLAG+PRESENT_F,0,IDTBASE+8*113	; IRQ9 - cascade
	gateInit	 0x08,irq10,INT_FLAG+PRESENT_F,0,IDTBASE+8*114	; IRQ10 - reserve
	gateInit	 0x08,irq11,INT_FLAG+PRESENT_F,0,IDTBASE+8*115	; IRQ11 - reserve
	gateInit	 0x08,irq12,INT_FLAG+PRESENT_F,0,IDTBASE+8*116	; IRQ12 - mouse
	gateInit	 0x08,irq13,INT_FLAG+PRESENT_F,0,IDTBASE+8*117	; IRQ13 - numeric coprocessor
	gateInit	 0x08,irq14,INT_FLAG+PRESENT_F,0,IDTBASE+8*118	; IRQ14 - fixed disk controller
	gateInit	 0x08,irq15,INT_FLAG+PRESENT_F,0,IDTBASE+8*119	; IRQ15 - reserve
		; ...
	gateInit	 0x08,syscalls,TRAP_FLAG+PRESENT_F,0,IDTBASE+8*128	; trap numero 0x80

	ret
;-------------------------------------------------------------------

;-------------------------------------------------------------------
; Routines interruptions (ISR)
;-------------------------------------------------------------------
interrupts:

irq0:
irq2:
irq3:
irq4:
irq5:
irq6:
irq7:
irq8:
irq9:
irq10:
irq11:
irq12:
irq13:
irq14:
irq15:
	mov al,0x20
	out 0x20,al	; EOI envoyee au PIC
	iret

irq1:
	cli
	call kbd_interrupt
	sti
	iret

end_interrupts:
;-------------------------------------------------------------------
