;-------------------------------------------------------------------
; init_pic
;	Synopsys: Initialisation du 8259.
;-------------------------------------------------------------------
init_pic:

	; Maitre
master:
	mov al,0x11 ; Initialisation de ICW1
	out 0x20,al
	jmp .1    ; temps d'attente
.1:
	mov al,0x20 	; Initialisation de ICW2
	out 0x21,al		; vecteur de depart = 32
	jmp .2    ; temps d'attente
.2:
	mov al,0x04 ; Initialisation de ICW3
	out 0x21,al
	jmp .3  
.3:
	mov al,0x01 ; Initialisation de ICW4
	out 0x21,al
	jmp .4   
.4:
	mov al,0xFF ; demasquage des interruptions
	out 0x21,al

	; Esclave
slave:
	mov al,0x11 ; Initialisation de ICW1
	out 0xA0,al
	jmp .1    ; temps d'attente
.1:
	mov al,0x70 ; Initialisation de ICW2
	out 0xA1,al		; vecteur depart = 96
	jmp .2    
.2:
	mov al,0x02 ; Initialisation de ICW3
	out 0xA1,al
	jmp .3    
.3:
	mov al,0x01 ; Initialisation de ICW4
	out 0xA1,al
	jmp .4   
.4:
	mov al,0xFF ; demasquage des interruptions
	out 0xA1,al

; Masquage des irqs
	mov al,0xFD		; j'autorise seulement l'irq1 (clavier).
	out 0x21,al

	ret
;-------------------------------------------------------------------
